"use strict";
this.haketilo_exports = this.haketilo_exports || {};
this.haketilo_exports["background/CORS_bypass_server.js"] = {};

(function() {
var globalThis = this.haketilo_this
{
/**
 * This file is part of Haketilo.
 *
 * Function: Allow other parts of the extension to bypass CORS by routing their
 *           request through this background script using one-off messages.
 *
 * Copyright (C) 2022 Wojtek Kosior <koszko@koszko.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * As additional permission under GNU GPL version 3 section 7, you
 * may distribute forms of that code without the copy of the GNU
 * GPL normally required by section 4, provided you include this
 * license notice and, in case of non-source distribution, a URL
 * through which recipients can access the Corresponding Source.
 * If you modify file(s) with this exception, you may extend this
 * exception to your version of the file(s), but you are not
 * obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * As a special exception to the GPL, any HTML file which merely
 * makes function calls to this code, and for that purpose
 * includes it by reference shall be deemed a separate work for
 * copyright law purposes. If you modify this code, you may extend
 * this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * I, Wojtek Kosior, thereby promise not to sue for violation of this file's
 * license. Although I request that you do not make use of this code in a
 * proprietary program, I am not going to enforce this in court.
 */

const browser = haketilo_exports["common/browser.js"].browser;

async function get_prop(object, prop, result_object, call_prop=false) {
    try {
	result_object[prop] = call_prop ? (await object[prop]()) : object[prop];
    } catch(e) {
	result_object[`error_${prop}`] = "" + e;
    }
}

async function perform_download(fetch_data, respond_cb) {
    try {
	const response = await fetch(fetch_data.url);
	const result = {};

	for (const prop of (fetch_data.to_get || []))
	    get_prop(response, prop, result);

	const to_call = (fetch_data.to_call || []);
	const promises = [];
	for (let i = 0; i < to_call.length; i++) {
	    const response_to_use = i === to_call.length - 1 ?
		response : response.clone();
	    promises.push(get_prop(response_to_use, to_call[i], result, true));
	}

	await Promise.all(promises);
	return result;
    } catch(e) {
	return {error: "" + e};
    }
}

function on_CORS_bypass_request([type, fetch_data], sender, respond_cb) {
    if (type !== "CORS_bypass")
	return;

    perform_download(fetch_data).then(respond_cb);

    return true;
}

function start() {
    browser.runtime.onMessage.addListener(on_CORS_bypass_request);
}
this.haketilo_exports["background/CORS_bypass_server.js"].start = (start);
}
}).call({
    haketilo_exports: this.haketilo_exports,
    haketilo_this:    this
});
